/*
 * e-signon-session-oauth.h
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with the program; if not, see <http://www.gnu.org/licenses/>
 *
 */

#ifndef E_GSIGNON_SESSION_OAUTH_H
#define E_GSIGNON_SESSION_OAUTH_H

#include <libebackend/libebackend.h>

/* Standard GObject macros */
#define E_TYPE_SIGNON_SESSION_OAUTH \
	(e_signon_session_oauth_get_type ())
#define E_SIGNON_SESSION_OAUTH(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST \
	((obj), E_TYPE_SIGNON_SESSION_OAUTH, ESignonSessionOAuth))
#define E_SIGNON_SESSION_OAUTH_CLASS(cls) \
	(G_TYPE_CHECK_CLASS_CAST \
	((cls), E_TYPE_SIGNON_SESSION_OAUTH, ESignonSessionOAuthClass))
#define E_IS_SIGNON_SESSION_OAUTH(obj) \
	(G_TYPE_CHECK_INSTANCE_TYPE \
	((obj), E_TYPE_SIGNON_SESSION_OAUTH))
#define E_IS_SIGNON_SESSION_OAUTH_CLASS(cls) \
	(G_TYPE_CHECK_CLASS_TYPE \
	((cls), E_TYPE_SIGNON_SESSION_OAUTH))
#define E_SIGNON_SESSION_OAUTH_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS \
	((obj), E_TYPE_SIGNON_SESSION_OAUTH, ESignonSessionOAuthClass))

G_BEGIN_DECLS

typedef struct _ESignonSessionOAuth ESignonSessionOAuth;
typedef struct _ESignonSessionOAuthClass ESignonSessionOAuthClass;
typedef struct _ESignonSessionOAuthPrivate ESignonSessionOAuthPrivate;

struct _ESignonSessionOAuth {
	EAuthenticationSession parent;
	ESignonSessionOAuthPrivate *priv;
};

struct _ESignonSessionOAuthClass {
	EAuthenticationSessionClass parent_class;
};

GType		e_signon_session_oauth_get_type
						(void) G_GNUC_CONST;
void		e_signon_session_oauth_type_register
						(GTypeModule *type_module);

G_END_DECLS

#endif /* E_GSIGNON_SESSION_OAUTH_H */